﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using LEAPI;

namespace LA2R3AcyclicsampleCsharp
{
    public partial class LA2R3ACYCLICSAMPLE : Form
    {
        bool connected = false;
        int lanio = 0;
        public System.Windows.Forms.TextBox pAI1;
        public System.Windows.Forms.TextBox pAI2;
        public System.Windows.Forms.TextBox pAI3;

        public LA2R3ACYCLICSAMPLE()
        {
            InitializeComponent();
            LALanio.Init();
            pAI1 = AI1;
            pAI2 = AI2;
            pAI3 = AI3;
        }

        ~LA2R3ACYCLICSAMPLE()
        {
            LALanio.End();
        }

        private void CONNECT_CheckedChanged(object sender, EventArgs e)
        {
            if (CONNECT.Checked)
            {
                try
                {
                    connect(ref lanio);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    CONNECT.Checked = false;
                    return;
                }
                connected = true;
            }
            else
            {
                LALanio.Close(lanio);
                connected = false;
            }
        }

        private void CYCLICTIME_SET_Click(object sender, EventArgs e)
        {
            if (connected != true)
            {
                MessageBox.Show("not connected");
                return;
            }
            if (CYCLICTIME.SelectedIndex != -1)
            {
                try
                {
                    cyclictimeset(lanio);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }

        private void CYCLICTRANSMIT_CheckedChanged(object sender, EventArgs e)
        {
            if (connected != true)
            {
                MessageBox.Show("not connected");
                return;
            }
            if (CYCLICTRANSMIT.Checked)
            {
                try
                {
                    cyclicstart(lanio);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                    CYCLICTRANSMIT.Checked = false;
                    return;
                }
            }
            else
            {
                cyclicstop(lanio);
            }
        }

        private void connect(ref int lanio)
        {
            string ipaddress = IPADDRESS.Text;
            lanio = LALanio.ConnectDirect(ipaddress, 2000);
            if (lanio == -1)
            {
                throw new Exception("Connect error");
            }
        }

        private void cyclictimeset(int lanio)
        {
            int err;
            err = LALanio.SetCyclicTransmit(lanio, CYCLICTIME.SelectedIndex);
            if (err == 0)
            {
                throw new Exception("CyclicTime Set error");
            }
        }

        private void cyclicstart(int lanio)
        {
            int err;
            LALanio.CyclicTransmitCallBack cb = callback;
            err = LALanio.StartCyclicTransmit(lanio, cb, (IntPtr) 0);
            if (err == 0)
            {
                throw new Exception("Cyclic Start error");
            }
        }

        private void cyclicstop(int lanio)
        {
            LALanio.StopCyclicTransmit(lanio);
        }

        private void callback(IntPtr user, IntPtr ai)
        {
            if (AI1.IsDisposed)
            {
                return; 
            }
            if (AI1.InvokeRequired)
            {
                LALanio.CyclicTransmitCallBack delegateMethod = new LALanio.CyclicTransmitCallBack(callback);
                this.Invoke(delegateMethod, new object[] { user, ai });
            }
            else
            {
                int[] aiarray = new int[5];
                Marshal.Copy(ai, aiarray, 0, 5);
                if (aiarray[0] == 0x8000000)
                {
                    AI1.Text = "error";
                    AI2.Text = "error";
                    AI3.Text = "error";
                }
                else
                {
                    AI1.Text = aiarray[0].ToString();
                    AI2.Text = aiarray[1].ToString();
                    AI3.Text = aiarray[2].ToString();
                }

            }

        }
    }
}
